    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * SortableTableModel.java
    029     * -----------------------
    030     * (C) Copyright 2000-2005, by Object Refinery Limited;
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: SortableTableModel.java,v 1.6 2008/09/10 09:26:11 mungady Exp $
    036     *
    037     * Changes (from 26-Oct-2001)
    038     * --------------------------
    039     * 26-Oct-2001 : Changed package to com.jrefinery.ui.* (DG);
    040     * 20-Nov-2001 : Made constructor protected (DG);
    041     * 14-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    042     *
    043     */
    044
    045    package org.jfree.ui;
    046
    047    import javax.swing.table.AbstractTableModel;
    048
    049    /**
    050     * The base class for a sortable table model.
    051     *
    052     * @author David Gilbert
    053     */
    054    public abstract class SortableTableModel extends AbstractTableModel {
    055
    056        /** The column on which the data is sorted (-1 for no sorting). */
    057        private int sortingColumn;
    058
    059        /** Indicates ascending (true) or descending (false) order. */
    060        private boolean ascending;
    061
    062        /**
    063         * Constructs a sortable table model.
    064         */
    065        public SortableTableModel() {
    066            this.sortingColumn = -1;
    067            this.ascending = true;
    068        }
    069
    070        /**
    071         * Returns the index of the sorting column, or -1 if the data is not sorted
    072         * on any column.
    073         *
    074         * @return the column used for sorting.
    075         */
    076        public int getSortingColumn() {
    077            return this.sortingColumn;
    078        }
    079
    080        /**
    081         * Returns <code>true</code> if the data is sorted in ascending order, and
    082         * <code>false</code> otherwise.
    083         *
    084         * @return <code>true</code> if the data is sorted in ascending order, and
    085         *         <code>false</code> otherwise.
    086         */
    087        public boolean isAscending() {
    088            return this.ascending;
    089        }
    090
    091        /**
    092         * Sets the flag that determines whether the sort order is ascending or
    093         * descending.
    094         *
    095         * @param flag  the flag.
    096         */
    097        public void setAscending(final boolean flag) {
    098            this.ascending = flag;
    099        }
    100
    101        /**
    102         * Sorts the table.
    103         *
    104         * @param column  the column to sort on (zero-based index).
    105         * @param ascending  a flag to indicate ascending order or descending order.
    106         */
    107        public void sortByColumn(final int column, final boolean ascending) {
    108            if (isSortable(column)) {
    109                this.sortingColumn = column;
    110            }
    111        }
    112
    113        /**
    114         * Returns a flag indicating whether or not a column is sortable.
    115         *
    116         * @param column  the column (zero-based index).
    117         *
    118         * @return boolean.
    119         */
    120        public boolean isSortable(final int column) {
    121            return false;
    122        }
    123
    124    }